<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
    >
      <el-form-item label="物资规格种类" prop="propertyName">
        <el-input
          disabled
          v-model="queryParams.propertyName"
          placeholder="请输入物资规格种类"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="物资规格" prop="valueName">
        <el-input
          v-model="queryParams.valueName"
          placeholder="请输入物资规格"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button
          v-no-more-click
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
        >搜索
        </el-button
        >
        <el-button
          v-no-more-click
          icon="el-icon-refresh"
          size="mini"
          @click="resetQuery"
        >重置
        </el-button
        >
        <el-button
          v-no-more-click
          type="warning"
          icon="el-icon-close"
          size="mini"
          @click="goBack"
        >返回
        </el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-no-more-click
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['iscs:propvalue:add']"
        >新增
        </el-button>
      </el-col>


      <el-col :span="1.5">
        <el-button
          v-no-more-click
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['iscs:propvalue:remove']"
        >批量删除
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="PropertyValueList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="编号" align="center" prop="recordId">
      </el-table-column>
      <el-table-column label="物资规格" align="center" prop="valueName"/>
      <el-table-column
        label="备注"
        align="center"
        prop="remark"
      />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
      />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['iscs:propvalue:edit']"
          >修改
          </el-button>

          <el-button
            v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['iscs:propvalue:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />
    <!-- 添加或修改物资对话框 -->
    <el-dialog :visible.sync="open" width="580px" append-to-body>
      <div slot="title" class="dialog-title">
        <i></i>
        <span class="title">{{ title }}</span>
      </div>
      <el-form ref="form" :model="form" :rules="rules" label-width="130px">
        <el-form-item label="物资规格种类编号" prop="propertyId">
          <el-input
            disabled
            style="width: 350px"
            v-model="form.propertyId"
            placeholder="请输入物资规格种类"
          />
        </el-form-item>
        <el-form-item label="物资规格" prop="valueName">
          <el-input
            style="width: 350px"
            v-model="form.valueName"
            placeholder="请输入物资规格"
          />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input
            type="textarea"
            style="width: 350px"
            v-model="form.remark"
            placeholder="请输入内容"
          />
        </el-form-item>
      </el-form>

      <div slot="footer" class="dialog-footer">
        <el-button v-no-more-click type="primary" @click="submitForm"
        >确 定
        </el-button
        >
        <el-button v-no-more-click @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import {
  PropertyValuePage,
  addPropertyValue,
  updatePropertyValue,
  deletePropertyValue,
  selectPropertyValueById
} from '@/api/mes/standard/propertyForm'

import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'

import Template from '@/views/print/printtemplate/list.vue'

export default {
  name: 'Team',
  components: {
    Template,
    Treeselect
  },
  dicts: ['material_status', 'file_type'],
  data() {
    return {
      //自动生成编码
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      codes: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 班组表格数据
      PropertyValueList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      createTime: '',
      queryParams: {
        current: 1,
        size: 10,
        propertyName: '',
        valueName: '',
        propertyId: null
      },
      // 表单参数
      form: {
        propertyId: ''
      },
      // 表单校验
      rules: {
        valueName: [
          { required: true, message: '物资规格不能为空', trigger: 'blur' }
        ],
        materialsTypeId: [
          { required: true, message: '物资类型不能为空', trigger: 'blur' }
        ]
      }

    }
  },
  created() {
    this.getList()

  },

  methods: {
    goBack() {
      this.$router.push('/material/standard')
    },
    /** 查询物资信息列表 */
    getList() {
      this.loading = true
      this.queryParams.propertyId = this.$route.query.propertyId
      this.queryParams.propertyName = this.$route.query.propertyName
      PropertyValuePage(this.queryParams).then((response) => {
        console.log(response, '获取物资说明 ')
        this.PropertyValueList = response.data.records
        this.total = response.data.total
        this.loading = false
      })
    },

    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        propertyName: ''
      }
      this.resetForm('form')
      this.autoGenFlag = false
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.recordId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },

    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.form.propertyId = this.$route.query.propertyId
      this.title = '新增物资规格'
      this.optType = 'add'
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      selectPropertyValueById(row.recordId).then((response) => {
        console.log(response, '修改')
        this.form = response.data
        this.open = true
        this.title = '修改物资规格'
        this.optType = 'edit'
      })
    },

    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          if (this.form.recordId != null) {
            updatePropertyValue(this.form).then((response) => {
              console.log(response, '修改返回')
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            console.log(this.form, '新增参数')
            addPropertyValue(this.form).then((response) => {
              console.log(response, '新增返回')
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },

    /** 删除按钮操作 */
    handleDelete(row) {
      const recordId = row.recordId || this.ids
      this.$modal
        .confirm('是否确认删除所选数据项？')
        .then(function() {
          return deletePropertyValue(recordId)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess('删除成功')
        })
        .catch(() => {
        })
    }

  }
}
</script>
<style lang="scss" src="@/assets/styles/dialog-title.scss" scoped>
.el-input-width {
  width: 380px !important;
}
</style>
